# -*- coding: utf-8 -*-
"""ananya_cnn_version2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1a1XoscccwztM2Pb0fmbU8m-5H6ykR3ma
"""

from google.colab import drive
drive.mount('/content/drive')

import torch
from torch import nn
import torch.nn.functional as F
from torch.autograd import Variable

import torchvision
from torchvision.transforms import ToTensor

import matplotlib.pyplot as plt
from torch.utils.data import Dataset, DataLoader
import numpy as np
import os
import glob

print(f"PyTorch version: {torch.__version__}\ntorchvision version: {torchvision.__version__}")

# Dataset preparation

class CustomDataset(Dataset):

    def __init__(self, datadir):
        self.imgs_path = datadir
        file_list = glob.glob(self.imgs_path + "*")

        self.data = []
        for class_path in file_list:
            class_name = class_path.split("/")[-1]
            for img_path in glob.glob(class_path + "/*.pt"):
                self.data.append([img_path, class_name])

        print(self.data)
        self.classification = {"bbh" : 0, "glitch": 1}
        self.img_dim = (21, 201)


    def __len__(self):
        return len(self.data)


    def __getitem__(self, idx):
        img_path, class_name = self.data[idx]
        #print(img_path)
        img = torch.load(os.path.join(img_path))
        img = img['orthosnr'].numpy()
        class_id = self.classification[class_name]
        img_tensor = torch.from_numpy(img)
        img_tensor = img_tensor.unsqueeze(dim=0)
        #print(img_tensor.shape)
        class_id = torch.tensor([class_id]).to(dtype=torch.float32)
        return img_tensor, class_id

# Training DataLoader

train_data = CustomDataset("drive/MyDrive/data/train/")
training_dataloader = DataLoader(train_data, batch_size=4, shuffle=True)

# Testing DataLoader

test_data = CustomDataset("drive/MyDrive/data/test/")
testing_dataloader = DataLoader(test_data, batch_size=4, shuffle=True)

training_image_batch, training_label_batch = next(iter(training_dataloader))

print(f"Image shape: {training_image_batch.shape} -> [batch_size, color_channels, height, width]")
print(f"Label shape: {training_label_batch.shape}")

print(training_label_batch.dtype)

testing_image_batch, testing_label_batch = next(iter(testing_dataloader))

print(f"Image shape: {testing_image_batch.shape} -> [batch_size, color_channels, height, width]")
print(f"Label shape: {testing_label_batch.shape}")

def findConv2dOutShape(hin,win,conv,pool=2):
    # find how the input image dimensions change with every layer
    kernel_size=conv.kernel_size
    stride=conv.stride
    padding=conv.padding
    dilation=conv.dilation

    print(kernel_size, stride, padding, dilation)

    hout=np.floor((hin+2*padding[0]-dilation[0]*(kernel_size[0]-1)-1)/stride[0]+1)
    wout=np.floor((win+2*padding[1]-dilation[1]*(kernel_size[1]-1)-1)/stride[1]+1)

    if pool:
        hout/=pool
        wout/=pool

    print(hout, wout, "\n")
    return int(hout),int(wout)

class ConvNet(nn.Module):
  # Model definition
    def __init__(self):
        super(ConvNet, self).__init__()
        self.conv1 = nn.Conv2d(1, 16, 5)  #padding 0 , stride = 1
        h,w=findConv2dOutShape(21,201,self.conv1)

        self.pool = nn.MaxPool2d(2, 2)

        self.conv2 = nn.Conv2d(16, 32, 5)
        h,w=findConv2dOutShape(h,w,self.conv2)

        self.dropout = nn.Dropout(0.5)

        self.fc1 = nn.Linear(32 * 47 * 2, 120)
        self.fc2 = nn.Linear(120, 84)
        self.fc3 = nn.Linear(84,32)
        self.fc4 = nn.Linear(32, 1)
        self.sigmoid = nn.Sigmoid()

    def forward(self, x):
        x = self.pool(F.relu(self.conv1(x)))
        x = self.pool(F.relu(self.conv2(x)))
        x = self.dropout(x)
        x = x.view(-1, 32 * 47 * 2)
        x = F.relu(self.fc1(x))
        x = self.dropout(F.relu(self.fc3(F.relu(self.fc2(x)))))
        x = self.sigmoid(self.fc4(x)).to(dtype=torch.float32)
        return x

model = ConvNet()

model(training_image_batch)  # seeing if everything checks out

from torchsummary import summary
summary(model, input_size=(1, 21, 201),device="cpu")

# Loss function
criterion = torch.nn.BCELoss()
# Optimizer
optimizer = torch.optim.Adam(model.parameters(), lr = 0.003)

n_epochs = 10

train_on_gpu = True if torch.cuda.is_available() else False

valid_loss_min = np.Inf # track change in validation loss

for epoch in range(1, n_epochs+1):

    # keep track of training and validation loss and accuracy
    train_loss = 0.0
    valid_loss = 0.0
    train_correct = 0
    train_total = 0
    valid_correct = 0
    valid_total = 0

    # train the model #
    model.train()
    for data, target in training_dataloader:
        # move tensors to GPU if CUDA is available
        if train_on_gpu:
            data, target = data.cuda(), target.cuda()
            model.cuda()
        # clear the gradients of all optimized variables
        optimizer.zero_grad()
        # forward pass: compute predicted outputs by passing inputs to the model
        output = model(data)
        # calculate the batch loss
        loss = criterion(output, target)
        # backward pass: compute gradient of the loss with respect to model parameters
        loss.backward()
        # perform a single optimization step (parameter update)
        optimizer.step()
        # update training loss
        train_loss += loss.item()*data.size(0)
        # update training accuracy
        predicted = torch.round(output)
        train_total += target.size(0)
        train_correct += (predicted == target).sum().item()

    # Validating the model
    model.eval()
    for data, target in testing_dataloader:
        if train_on_gpu:
            data, target = data.cuda(), target.cuda()
        # forward pass: compute predicted outputs by passing inputs to the model
        output = model(data)
        # calculate the batch loss
        loss = criterion(output, target)
        # update average validation loss
        valid_loss += loss.item()*data.size(0)
        # update validation accuracy
        predicted = torch.round(output)
        valid_total += target.size(0)
        valid_correct += (predicted == target).sum().item()

    # calculate average losses
    train_loss = train_loss/len(training_dataloader)
    valid_loss = valid_loss/len(testing_dataloader)

    # calculate average accuracy
    train_accuracy = 100 * train_correct / train_total
    valid_accuracy = 100 * valid_correct / valid_total

    # print training/validation statistics
    print('Epoch: {} \tTraining Loss: {:.6f} \tValidation Loss: {:.6f} \tTraining Accuracy: {:.2f}% \tValidation Accuracy: {:.2f}%'.format(
        epoch, train_loss, valid_loss, train_accuracy, valid_accuracy))

    # save model if validation loss has decreased
    if valid_loss <= valid_loss_min:
        print('Validation loss decreased ({:.6f} --> {:.6f}).  Saving model ...'.format(
        valid_loss_min,
        valid_loss))
        torch.save(model.state_dict(), 'model.pt')
        valid_loss_min = valid_loss

testing_image_batch, testing_label_batch = next(iter(testing_dataloader))
if train_on_gpu:
  print(model(testing_image_batch.cuda()), testing_label_batch.cuda())
else:
  print(model(testing_image_batch), testing_label_batch)

